<?php
// send some CORS headers so the API can be called from anywhere
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: OPTIONS, GET, POST, PUT, DELETE");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");
header("Cache-Control: no-cache");
// header("Access-Control-Max-Age: 3600");//3600 seconds
// 1)private,max-age=60 (browser is only allowed to cache) 2)no-store(public),max-age=60 (all intermidiary can cache, not browser alone)  3)no-cache (no ceaching at all)

include "../../apifunctions.php";
include "../../config/connectdb.php";
include "../../config/utilities.php";

// Set the Endpoint dynamically
$endpoint = "/api/user/" . basename($_SERVER['PHP_SELF']);

// Function to enforce request methods
function enforceMethod($allowedMethod) {
    $requestMethod = strtoupper($_SERVER['REQUEST_METHOD']); // Normalize case
    if ($requestMethod !== strtoupper($allowedMethod)) {
        $errordesc = "Method not allowed";
        $linktosolve = "https://";
        $errordata = returnError7003($errordesc, $linktosolve);
        $text = "Method used not allowed";
        $data = returnErrorArray($text, $requestMethod, $GLOBALS['endpoint'], $errordata);
        respondMethodNotAlowed($data);
        exit;
    }
}
?>
